Loading...
Searching...
No Matches
MMFF/DistanceConstraint.h
Go to the documentation of this file.
//
// Copyright (C) 2013 Paolo Tosco
//
// Copyright (C) 2004-2006 Rational Discovery LLC
//
// @@ All Rights Reserved @@
// This file is part of the RDKit.
// The contents are covered by the terms of the BSD license
// which is included in the file license.txt, found at the root
// of the RDKit source tree.
//
#include <RDGeneral/export.h>
#ifndef __RD_MMFFDISTANCECONSTRAINT_H__
#define __RD_MMFFDISTANCECONSTRAINT_H__
#include <iostream>
#include <ForceField/Contrib.h>
namespace ForceFields {
namespace MMFF {
//! A distance range constraint modelled after a BondStretchContrib
class RDKIT_FORCEFIELD_EXPORT DistanceConstraintContrib
: public ForceFieldContrib {
public:
DistanceConstraintContrib() {}
//! Constructor
/*!
\param owner pointer to the owning ForceField
\param idx1 index of end1 in the ForceField's positions
\param idx2 index of end2 in the ForceField's positions
\param minLen minimum distance
\param maxLen maximum distance
\param forceConst force Constant
*/
DistanceConstraintContrib(ForceField *owner, unsigned int idx1,
unsigned int idx2, double minLen, double maxLen,
double forceConst);
DistanceConstraintContrib(ForceField *owner, unsigned int idx1,
unsigned int idx2, bool relative, double minLen,
double maxLen, double forceConst);
~DistanceConstraintContrib() override {
// std::cerr << " ==== Destroy constraint " << d_end1Idx << " " << d_end2Idx
// << std::endl;
}
double getEnergy(double *pos) const override;
void getGrad(double *pos, double *grad) const override;
DistanceConstraintContrib *copy() const override {
return new DistanceConstraintContrib(*this);
}
private:
int d_end1Idx{-1}, d_end2Idx{-1}; //!< indices of end points
double d_minLen, d_maxLen; //!< rest length of the bond
double d_forceConstant; //!< force constant of the bond
};
} // namespace MMFF
} // namespace ForceFields
#endif
Contrib.h
ForceFields::ForceFieldContrib
abstract base class for contributions to ForceFields
Definition Contrib.h:18
ForceFields::ForceField
A class to store forcefields and handle minimization.
Definition ForceField.h:79
ForceFields::MMFF::DistanceConstraintContrib
A distance range constraint modelled after a BondStretchContrib.
Definition MMFF/DistanceConstraint.h:23
ForceFields::MMFF::DistanceConstraintContrib::~DistanceConstraintContrib
~DistanceConstraintContrib() override
Definition MMFF/DistanceConstraint.h:43
ForceFields::MMFF::DistanceConstraintContrib::DistanceConstraintContrib
DistanceConstraintContrib(ForceField *owner, unsigned int idx1, unsigned int idx2, double minLen, double maxLen, double forceConst)
Constructor.
ForceFields::MMFF::DistanceConstraintContrib::getGrad
void getGrad(double *pos, double *grad) const override
calculates our contribution to the gradients of a position
ForceFields::MMFF::DistanceConstraintContrib::DistanceConstraintContrib
DistanceConstraintContrib()
Definition MMFF/DistanceConstraint.h:25
ForceFields::MMFF::DistanceConstraintContrib::getEnergy
double getEnergy(double *pos) const override
returns our contribution to the energy of a position
ForceFields::MMFF::DistanceConstraintContrib::copy
DistanceConstraintContrib * copy() const override
return a copy
Definition MMFF/DistanceConstraint.h:50
ForceFields::MMFF::DistanceConstraintContrib::DistanceConstraintContrib
DistanceConstraintContrib(ForceField *owner, unsigned int idx1, unsigned int idx2, bool relative, double minLen, double maxLen, double forceConst)
export.h
RDKIT_FORCEFIELD_EXPORT
#define RDKIT_FORCEFIELD_EXPORT
Definition export.h:185
ForceFields
Definition TorsionAngleM6.h:22